package com.xin.shardingspherejdbcdemo.service.impl;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.github.pagehelper.PageHelper;
import com.xin.shardingspherejdbcdemo.config.util.SnowFlake;
import com.xin.shardingspherejdbcdemo.entity.User;
import com.xin.shardingspherejdbcdemo.entity.vo.PageVo;
import com.xin.shardingspherejdbcdemo.mapper.UserMapper;
import com.xin.shardingspherejdbcdemo.service.UserService;
import com.xin.shardingspherejdbcdemo.utils.DateUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.Date;
import java.util.List;


@Service
public class UserServiceImpl implements UserService {

    @Autowired
    private UserMapper userMapper;

    @Override
    public PageVo list(int pageNum, int pageSize, String name, Integer age) {
        QueryWrapper queryWrapper = new QueryWrapper();
        queryWrapper.like("name", name);
        int count = userMapper.selectCount(queryWrapper);
        queryWrapper.orderByDesc("age");
        PageHelper.startPage(pageNum, pageSize);
        List<User> list = userMapper.selectList(queryWrapper);
        return PageVo.data(list, count);
    }


    @Override
    public User save(User user) {
        SnowFlake snowFlake = new SnowFlake(2, 3);
        user.setId(snowFlake.nextId());
        userMapper.insert(user);
        return user;
    }


    @Override
    public User info(Long id) {
        return userMapper.selectById(id);
    }

    @Override
    @Transactional
    public User update(User user) {
        userMapper.updateById(user);
        return user;
    }

    @Override
    @Transactional
    public Long delete(Long id) {
        userMapper.deleteById(id);
        return id;
    }


}
