server:
  port: 8086
mybatis:
  mapper-locations: classpath*:mapper/*.xml
#指定mybatis信息
# 数据源 主库、从库 -- 读写分离
#spring.shardingsphere.datasource.names=master,slave0
# 数据源 主库 --仅分表不分库
#spring.shardingsphere.datasource.names=master
# 数据源 主库db0、主库db1 -- 分库分表
spring:
  shardingsphere:
    datasource:
      names: master0,master1
      # 数据源 主库
      master0:
        type: com.alibaba.druid.pool.DruidDataSource
        driver-class-name: com.mysql.cj.jdbc.Driver
        url: jdbc:mysql://182.61.59.216:3306/db0?useUnicode=true&characterEncoding=UTF-8&serverTimezone=Asia/Shanghai
        username: root
        password: 123456
      # 数据源 主库
      master1:
        type: com.alibaba.druid.pool.DruidDataSource
        driver-class-name: com.mysql.cj.jdbc.Driver
        url: jdbc:mysql://182.61.59.216:3306/db1?useUnicode=true&characterEncoding=UTF-8&serverTimezone=Asia/Shanghai
        username: root
        password: 123456
      ## 数据源 从库
#      slave0:
#        type: com.alibaba.druid.pool.DruidDataSource
#        driver-class-name: com.mysql.cj.jdbc.Driver
#        url: jdbc:mysql://182.61.59.216:3306/db1?useUnicode=true&characterEncoding=UTF-8&serverTimezone=Asia/Shanghai
#        username: root
#        password: 123456

    ## 读写分离
    ##spring.shardingsphere.masterslave.load-balance-algorithm-type=round_robin
    #spring.shardingsphere.masterslave.name=ms
    #spring.shardingsphere.masterslave.master-data-source-name=master
    #spring.shardingsphere.masterslave.slave-data-source-names=slave0

    ## 分库
    #根据ID分库
    #spring.shardingsphere.sharding.default-database-strategy.inline.sharding-column=id
    #spring.shardingsphere.sharding.default-database-strategy.inline.algorithm-expression=master$->{id % 2}

    #根据年龄分库
    sharding:
      default-database-strategy:
        inline:
          sharding-column: age
          algorithm-expression: master$->{age > 30?0:1}
        #数据分表规则--仅分表不分库
        #注意：tables.user中的user是逻辑表
        #仅分表时使用，单一写表，指定所需分的表，分user1、user2
        #spring.shardingsphere.sharding.tables.user.actual-data-nodes=master.user$->{0..1}
        #同时分库分表时使用
        tables.user:
          actual-data-nodes: master$->{0..1}.user$->{0..1}
          ##行表达式分片策略
          user:
            table-strategy:
              inline:
                sharding-column: id
                #分表两个，所以规则为主键除以2取模
                algorithm-expression: user$->{id % 2}

  ##用于单分片键的标准分片场景
  ##指定自增主键
  #spring.shardingsphere.sharding.tables.user.key-generator.column= id
  ##自增列值生成器类型，缺省表示使用默认自增列值生成器。可使用用户自定义的列值生成器或选择内置类型：SNOWFLAKE/UUID
  #spring.shardingsphere.sharding.tables.user.key-generator.type= SNOWFLAKE
  #打印sql
  props:
    sql:
      show: true